// /////////////////////////////////////////////////////////////////////////
// SystemC code automatically generated by hif2sc
// Part of HIFSuite - Version stable
// Site: www.hifsuite.com - Contact: hifsuite@edalab.it
//
// HIFSuite copyright: EDALab s.r.l. - Networked Embedded Systems
// Site: www.edalab.it - Contact: info@edalab.it
// /////////////////////////////////////////////////////////////////////////


#include "../inc/watchdog_apb_wrapper.hpp"




watchdog_apb_wrapper::watchdog_apb_wrapper( sc_core::sc_module_name name_ ) :
    sc_core::sc_module( name_ ),
    pclk("pclk"),
    presetn("presetn"),
    paddr("paddr"),
    psel("psel"),
    penable("penable"),
    pwrite("pwrite"),
    pwdata("pwdata"),
    pready("pready"),
    prdata("prdata"),
    prdata_mspw("prdata_mspw", 32L),
    prdata_partial2("prdata_partial2"),
    prdata_partial1(false),
    prdata_partial0(uint16_t(0U)),
    start_counting(false),
    stop_counting(false),
    max_counter(uint16_t(0U)),
    actual_counter("actual_counter"),
    counter_flag("counter_flag"),
    dout_rdy("dout_rdy"),
    watchdog_0_state("watchdog_0_state"),
    old_watchdog_0_state(uint8_t(0U)),
    watchdog_0_state_sig_var(uint8_t(0U)),
    watchdog_0_next_state("watchdog_0_next_state"),
    watchdog_0_internal_max_counter("watchdog_0_internal_max_counter"),
    watchdog_0_st_1(uint8_t(0U)),
    watchdog_0_st_2(uint8_t(1U)),
    watchdog_0_st_3(uint8_t(2U)),
    watchdog_0_st_4(uint8_t(3U)),
    watchdog_0_st_5(uint8_t(4U))

{
    pready.initialize( false );
    prdata.initialize( 0UL );
    for (int ind_1 = 31L; ind_1 >= 0L; ind_1 = ind_1 - 1)
    {
        prdata_mspw[ind_1] = false;
    }
    prdata_partial2 = uint16_t(0U);
    actual_counter = uint16_t(0U);
    counter_flag = false;
    dout_rdy = false;
    watchdog_0_state = uint8_t(0U);
    watchdog_0_next_state = uint8_t(0U);
    watchdog_0_internal_max_counter = 0UL;

    SC_METHOD( watchdog_0_process );
    sensitive << watchdog_0_state << pwdata;

    SC_METHOD( watchdog_0_process_0 );
    sensitive << pclk.pos();

    SC_METHOD( globact_process );
    sensitive << dout_rdy;

    SC_METHOD( globact_process_0 );
    sensitive << actual_counter;

    SC_METHOD( globact_process_1 );
    sensitive << counter_flag;

    SC_METHOD( globact_process_2 );
    sensitive << prdata_partial2;

    SC_METHOD( globact_process_18 );

    SC_METHOD( prdata_mspw_proc_tgt );
    for (int ind_2 = 31L; ind_2 >= 0L; ind_2 = ind_2 - 1)
    {
        sensitive << prdata_mspw[ind_2];
    }


}

watchdog_apb_wrapper::~watchdog_apb_wrapper()
{}

void watchdog_apb_wrapper::hif_cone_max_counter()
{
    max_counter = pwdata.read();
}


void watchdog_apb_wrapper::hif_cone_prdata_partial0()
{
    prdata_partial0 = actual_counter.read();
}


void watchdog_apb_wrapper::hif_cone_prdata_partial1()
{
    prdata_partial1 = counter_flag.read();
}


void watchdog_apb_wrapper::hif_cone_start_counting()
{
    start_counting = pwdata.read() >> 16UL & 1UL;
}


void watchdog_apb_wrapper::hif_cone_stop_counting()
{
    stop_counting = pwdata.read() >> 24UL & 1UL;
}


void watchdog_apb_wrapper::hif_cone_watchdog_0_state()
{
    if (static_cast< uint8_t >( watchdog_0_state.read() & uint8_t(7U) ) != static_cast<
         uint8_t >( old_watchdog_0_state & uint8_t(7U) ))
    {
        old_watchdog_0_state = watchdog_0_state.read() & uint8_t(7U);
        watchdog_0_state_sig_var = old_watchdog_0_state & uint8_t(7U);
    }
}


void watchdog_apb_wrapper::start_of_simulation()
{
    hif_cone_watchdog_0_state();
    watchdog_0_state_sig_var = watchdog_0_st_1 & uint8_t(7U);
    watchdog_0_state = watchdog_0_state_sig_var & uint8_t(7U);
    watchdog_0_next_state = watchdog_0_st_1 & uint8_t(7U);
    actual_counter = uint16_t(0U);
    counter_flag = false;
}


void watchdog_apb_wrapper::watchdog_0_process()
{
    hif_cone_watchdog_0_state();
    if (watchdog_0_st_1 == watchdog_0_state_sig_var)
    {
        hif_cone_start_counting();
        if (start_counting == true)
        {
            watchdog_0_next_state = watchdog_0_st_2 & uint8_t(7U);
        }
    }
    else if (watchdog_0_st_2 == watchdog_0_state_sig_var)
    {
        hif_cone_stop_counting();
        if (stop_counting == true)
        {
            watchdog_0_next_state = watchdog_0_st_3 & uint8_t(7U);
        }
    }
    else if (watchdog_0_st_3 == watchdog_0_state_sig_var)
    {
        watchdog_0_next_state = watchdog_0_st_4 & uint8_t(7U);
    }
    else if (watchdog_0_st_4 == watchdog_0_state_sig_var)
    {
        hif_cone_start_counting();
        if (start_counting == true)
        {
            watchdog_0_next_state = watchdog_0_st_5 & uint8_t(7U);
        }
    }
    else if (watchdog_0_st_5 == watchdog_0_state_sig_var)
    {
        watchdog_0_next_state = watchdog_0_st_2 & uint8_t(7U);
    }
}

void watchdog_apb_wrapper::watchdog_0_process_0()
{
    hif_cone_watchdog_0_state();
    watchdog_0_state = watchdog_0_next_state.read() & uint8_t(7U);
    if (watchdog_0_next_state.read() == watchdog_0_st_1)
    {
        hif_cone_max_counter();
        watchdog_0_internal_max_counter = max_counter;
        actual_counter = uint16_t(0U);
        counter_flag = false;
        dout_rdy = false;
    }
    else if (watchdog_0_next_state.read() == watchdog_0_st_2)
    {
        actual_counter = actual_counter.read() + 2UL;
        if (actual_counter.read() >= watchdog_0_internal_max_counter.read() + 1260UL
            )
        {
            counter_flag = true;
        }
        dout_rdy = false;
    }
    else if (watchdog_0_next_state.read() == watchdog_0_st_3)
    {
        actual_counter = actual_counter.read() - uint16_t(1260U);
        dout_rdy = false;
    }
    else if (watchdog_0_next_state.read() == watchdog_0_st_4)
    {
        dout_rdy = true;
        hif_cone_max_counter();
        watchdog_0_internal_max_counter = max_counter;
    }
    else if (watchdog_0_next_state.read() == watchdog_0_st_5)
    {
        actual_counter = uint16_t(0U);
        counter_flag = false;
        dout_rdy = false;
    }
}

void watchdog_apb_wrapper::globact_process()
{
    pready = dout_rdy.read();
}

void watchdog_apb_wrapper::globact_process_0()
{
    hif_cone_prdata_partial0();
    prdata_mspw[15L] = static_cast< uint16_t >( prdata_partial0 >> uint16_t(15U
        ) ) & uint16_t(1U);
    prdata_mspw[14L] = static_cast< uint16_t >( prdata_partial0 >> uint16_t(14U
        ) ) & uint16_t(1U);
    prdata_mspw[13L] = static_cast< uint16_t >( prdata_partial0 >> uint16_t(13U
        ) ) & uint16_t(1U);
    prdata_mspw[12L] = static_cast< uint16_t >( prdata_partial0 >> uint16_t(12U
        ) ) & uint16_t(1U);
    prdata_mspw[11L] = static_cast< uint16_t >( prdata_partial0 >> uint16_t(11U
        ) ) & uint16_t(1U);
    prdata_mspw[10L] = static_cast< uint16_t >( prdata_partial0 >> uint16_t(10U
        ) ) & uint16_t(1U);
    prdata_mspw[9L] = static_cast< uint16_t >( prdata_partial0 >> uint16_t(9U) 
        ) & uint16_t(1U);
    prdata_mspw[8L] = static_cast< uint16_t >( prdata_partial0 >> uint16_t(8U) 
        ) & uint16_t(1U);
    prdata_mspw[7L] = static_cast< uint16_t >( prdata_partial0 >> uint16_t(7U) 
        ) & uint16_t(1U);
    prdata_mspw[6L] = static_cast< uint16_t >( prdata_partial0 >> uint16_t(6U) 
        ) & uint16_t(1U);
    prdata_mspw[5L] = static_cast< uint16_t >( prdata_partial0 >> uint16_t(5U) 
        ) & uint16_t(1U);
    prdata_mspw[4L] = static_cast< uint16_t >( prdata_partial0 >> uint16_t(4U) 
        ) & uint16_t(1U);
    prdata_mspw[3L] = static_cast< uint16_t >( prdata_partial0 >> uint16_t(3U) 
        ) & uint16_t(1U);
    prdata_mspw[2L] = static_cast< uint16_t >( prdata_partial0 >> uint16_t(2U) 
        ) & uint16_t(1U);
    prdata_mspw[1L] = static_cast< uint16_t >( prdata_partial0 >> uint16_t(1U) 
        ) & uint16_t(1U);
    prdata_mspw[0L] = prdata_partial0 & uint16_t(1U);
}

void watchdog_apb_wrapper::globact_process_1()
{
    hif_cone_prdata_partial1();
    prdata_mspw[16L] = prdata_partial1;
}

void watchdog_apb_wrapper::globact_process_2()
{
    prdata_mspw[31L] = static_cast< uint16_t >( prdata_partial2.read() >> uint16_t
        (14U) ) & uint16_t(1U);
    prdata_mspw[30L] = static_cast< uint16_t >( prdata_partial2.read() >> uint16_t
        (13U) ) & uint16_t(1U);
    prdata_mspw[29L] = static_cast< uint16_t >( prdata_partial2.read() >> uint16_t
        (12U) ) & uint16_t(1U);
    prdata_mspw[28L] = static_cast< uint16_t >( prdata_partial2.read() >> uint16_t
        (11U) ) & uint16_t(1U);
    prdata_mspw[27L] = static_cast< uint16_t >( prdata_partial2.read() >> uint16_t
        (10U) ) & uint16_t(1U);
    prdata_mspw[26L] = static_cast< uint16_t >( prdata_partial2.read() >> uint16_t
        (9U) ) & uint16_t(1U);
    prdata_mspw[25L] = static_cast< uint16_t >( prdata_partial2.read() >> uint16_t
        (8U) ) & uint16_t(1U);
    prdata_mspw[24L] = static_cast< uint16_t >( prdata_partial2.read() >> uint16_t
        (7U) ) & uint16_t(1U);
    prdata_mspw[23L] = static_cast< uint16_t >( prdata_partial2.read() >> uint16_t
        (6U) ) & uint16_t(1U);
    prdata_mspw[22L] = static_cast< uint16_t >( prdata_partial2.read() >> uint16_t
        (5U) ) & uint16_t(1U);
    prdata_mspw[21L] = static_cast< uint16_t >( prdata_partial2.read() >> uint16_t
        (4U) ) & uint16_t(1U);
    prdata_mspw[20L] = static_cast< uint16_t >( prdata_partial2.read() >> uint16_t
        (3U) ) & uint16_t(1U);
    prdata_mspw[19L] = static_cast< uint16_t >( prdata_partial2.read() >> uint16_t
        (2U) ) & uint16_t(1U);
    prdata_mspw[18L] = static_cast< uint16_t >( prdata_partial2.read() >> uint16_t
        (1U) ) & uint16_t(1U);
    prdata_mspw[17L] = prdata_partial2.read() & uint16_t(1U);
}

void watchdog_apb_wrapper::globact_process_18()
{
    prdata_partial2 = uint16_t(0U);
}

void watchdog_apb_wrapper::prdata_mspw_proc_tgt()
{
    prdata = static_cast< uint32_t >( prdata_mspw[1L].read() ) << 1L | prdata_mspw
        [0L].read() | static_cast< uint32_t >( prdata_mspw[2L].read() ) << 2L |
         static_cast< uint32_t >( prdata_mspw[3L].read() ) << 3L | static_cast<
         uint32_t >( prdata_mspw[4L].read() ) << 4L | static_cast< uint32_t >( prdata_mspw
        [5L].read() ) << 5L | static_cast< uint32_t >( prdata_mspw[6L].read() )
         << 6L | static_cast< uint32_t >( prdata_mspw[7L].read() ) << 7L | static_cast<
         uint32_t >( prdata_mspw[8L].read() ) << 8L | static_cast< uint32_t >( prdata_mspw
        [9L].read() ) << 9L | static_cast< uint32_t >( prdata_mspw[10L].read() 
        ) << 10L | static_cast< uint32_t >( prdata_mspw[11L].read() ) << 11L | static_cast<
         uint32_t >( prdata_mspw[12L].read() ) << 12L | static_cast< uint32_t >
        ( prdata_mspw[13L].read() ) << 13L | static_cast< uint32_t >( prdata_mspw
        [14L].read() ) << 14L | static_cast< uint32_t >( prdata_mspw[15L].read(
        ) ) << 15L | static_cast< uint32_t >( prdata_mspw[16L].read() ) << 16L |
         static_cast< uint32_t >( prdata_mspw[17L].read() ) << 17L | static_cast<
         uint32_t >( prdata_mspw[18L].read() ) << 18L | static_cast< uint32_t >
        ( prdata_mspw[19L].read() ) << 19L | static_cast< uint32_t >( prdata_mspw
        [20L].read() ) << 20L | static_cast< uint32_t >( prdata_mspw[21L].read(
        ) ) << 21L | static_cast< uint32_t >( prdata_mspw[22L].read() ) << 22L |
         static_cast< uint32_t >( prdata_mspw[23L].read() ) << 23L | static_cast<
         uint32_t >( prdata_mspw[24L].read() ) << 24L | static_cast< uint32_t >
        ( prdata_mspw[25L].read() ) << 25L | static_cast< uint32_t >( prdata_mspw
        [26L].read() ) << 26L | static_cast< uint32_t >( prdata_mspw[27L].read(
        ) ) << 27L | static_cast< uint32_t >( prdata_mspw[28L].read() ) << 28L |
         static_cast< uint32_t >( prdata_mspw[29L].read() ) << 29L | static_cast<
         uint32_t >( prdata_mspw[30L].read() ) << 30L | static_cast< uint32_t >
        ( prdata_mspw[31L].read() ) << 31L;
}



